# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PrivatePricingcardassignmentsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'org_id': 'str',
        'pricing_card_id': 'str',
        'entity_id': 'str',
        'entity_type': 'str',
        'created_at': 'datetime',
        'last_updated_at': 'datetime',
        'entity_name': 'str',
        'pricing_card_name': 'str'
    }

    attribute_map = {
        'id': 'id',
        'org_id': 'orgId',
        'pricing_card_id': 'pricingCardId',
        'entity_id': 'entityId',
        'entity_type': 'entityType',
        'created_at': 'createdAt',
        'last_updated_at': 'lastUpdatedAt',
        'entity_name': 'entityName',
        'pricing_card_name': 'pricingCardName'
    }

    def __init__(self, id=None, org_id=None, pricing_card_id=None, entity_id=None, entity_type=None, created_at=None, last_updated_at=None, entity_name=None, pricing_card_name=None):  # noqa: E501
        """PrivatePricingcardassignmentsBody - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._org_id = None
        self._pricing_card_id = None
        self._entity_id = None
        self._entity_type = None
        self._created_at = None
        self._last_updated_at = None
        self._entity_name = None
        self._pricing_card_name = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if org_id is not None:
            self.org_id = org_id
        self.pricing_card_id = pricing_card_id
        if entity_id is not None:
            self.entity_id = entity_id
        if entity_type is not None:
            self.entity_type = entity_type
        if created_at is not None:
            self.created_at = created_at
        if last_updated_at is not None:
            self.last_updated_at = last_updated_at
        if entity_name is not None:
            self.entity_name = entity_name
        if pricing_card_name is not None:
            self.pricing_card_name = pricing_card_name

    @property
    def id(self):
        """Gets the id of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Id of the pricingCardAssignment  # noqa: E501

        :return: The id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PrivatePricingcardassignmentsBody.

        Id of the pricingCardAssignment  # noqa: E501

        :param id: The id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def org_id(self):
        """Gets the org_id of this PrivatePricingcardassignmentsBody.  # noqa: E501

        OrgId of the pricingCardAssignment  # noqa: E501

        :return: The org_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PrivatePricingcardassignmentsBody.

        OrgId of the pricingCardAssignment  # noqa: E501

        :param org_id: The org_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def pricing_card_id(self):
        """Gets the pricing_card_id of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Pricing card id  # noqa: E501

        :return: The pricing_card_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._pricing_card_id

    @pricing_card_id.setter
    def pricing_card_id(self, pricing_card_id):
        """Sets the pricing_card_id of this PrivatePricingcardassignmentsBody.

        Pricing card id  # noqa: E501

        :param pricing_card_id: The pricing_card_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """
        if pricing_card_id is None:
            raise ValueError("Invalid value for `pricing_card_id`, must not be `None`")  # noqa: E501

        self._pricing_card_id = pricing_card_id

    @property
    def entity_id(self):
        """Gets the entity_id of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Pricing card assigned entity id  # noqa: E501

        :return: The entity_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._entity_id

    @entity_id.setter
    def entity_id(self, entity_id):
        """Sets the entity_id of this PrivatePricingcardassignmentsBody.

        Pricing card assigned entity id  # noqa: E501

        :param entity_id: The entity_id of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """

        self._entity_id = entity_id

    @property
    def entity_type(self):
        """Gets the entity_type of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Pricing card assigned entity type  # noqa: E501

        :return: The entity_type of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """Sets the entity_type of this PrivatePricingcardassignmentsBody.

        Pricing card assigned entity type  # noqa: E501

        :param entity_type: The entity_type of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALL", "PROJECT", "CLOUDZONE"]  # noqa: E501
        if entity_type not in allowed_values:
            raise ValueError(
                "Invalid value for `entity_type` ({0}), must be one of {1}"  # noqa: E501
                .format(entity_type, allowed_values)
            )

        self._entity_type = entity_type

    @property
    def created_at(self):
        """Gets the created_at of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PrivatePricingcardassignmentsBody.

        Creation time  # noqa: E501

        :param created_at: The created_at of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def last_updated_at(self):
        """Gets the last_updated_at of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Updated time  # noqa: E501

        :return: The last_updated_at of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_at

    @last_updated_at.setter
    def last_updated_at(self, last_updated_at):
        """Sets the last_updated_at of this PrivatePricingcardassignmentsBody.

        Updated time  # noqa: E501

        :param last_updated_at: The last_updated_at of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: datetime
        """

        self._last_updated_at = last_updated_at

    @property
    def entity_name(self):
        """Gets the entity_name of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Pricing card assigned entity name  # noqa: E501

        :return: The entity_name of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._entity_name

    @entity_name.setter
    def entity_name(self, entity_name):
        """Sets the entity_name of this PrivatePricingcardassignmentsBody.

        Pricing card assigned entity name  # noqa: E501

        :param entity_name: The entity_name of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """

        self._entity_name = entity_name

    @property
    def pricing_card_name(self):
        """Gets the pricing_card_name of this PrivatePricingcardassignmentsBody.  # noqa: E501

        Pricing card name  # noqa: E501

        :return: The pricing_card_name of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :rtype: str
        """
        return self._pricing_card_name

    @pricing_card_name.setter
    def pricing_card_name(self, pricing_card_name):
        """Sets the pricing_card_name of this PrivatePricingcardassignmentsBody.

        Pricing card name  # noqa: E501

        :param pricing_card_name: The pricing_card_name of this PrivatePricingcardassignmentsBody.  # noqa: E501
        :type: str
        """

        self._pricing_card_name = pricing_card_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PrivatePricingcardassignmentsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrivatePricingcardassignmentsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
